%% 1. read mrc file and crop image

% Input parameters:
disp('Pad_Origin_X=');disp(Pad_Origin_X);
disp('Pad_Origin_Y=');disp(Pad_Origin_Y);
disp('Inside_Radius_Ang=');disp(Inside_Radius_Ang);
disp('Outside_Radius_Ang=');disp(Outside_Radius_Ang);
disp('Pixel_Ang=');disp(Pixel_Ang);
disp('Threshold=');disp(Threshold);
disp('expand_pixel=');disp(expand_pixel);
disp('pad_out_opt=');disp(pad_out_opt);
disp('name_list=');disp(name_list);
disp('name_sub=');disp(name_sub);



%IMAGE FILE READIN 
   img = ReadMRC(name_list);

%%% auto_padding : bgh Oct-18 2017

  img_left = img(:,1);
  img_top  = img(1,:);
  dummy = size(img);
  row_count = dummy(1) 
  column_count = dummy(2) 
  Pad_Box_Size = max(row_count, column_count) + Pad_Origin_X*2  ; 
  Pad_Box_Size = round(Pad_Box_Size / 10) * 10 ; %%  bg_FastSubtract imresize limits box_size choice  
  img_right = img(:,column_count);
  img_bottom = img(row_count,:);
  mean_edge  =  ( mean(img_left) + mean(img_right) + mean(img_top) + mean(img_bottom) ) /4   %%% just information
  mean_all = mean(mean(img)) 
  left_st_minus_1 = Pad_Box_Size ; 

  corner_pad_stROW = Pad_Origin_X - 1; 
  corner_pad_stCOL = Pad_Origin_Y - 1; 

  coner_pad_endROW = Pad_Box_Size - row_count - corner_pad_stROW  ;     
  coner_pad_endCOL = Pad_Box_Size - column_count - corner_pad_stCOL ; 



   

  pad_1 =     padarray(img,   [ corner_pad_stROW   corner_pad_stCOL ],mean_all, 'pre');
  pad_image = padarray(pad_1, [ coner_pad_endROW   coner_pad_endCOL ], mean_all, 'post');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 unit_cell_pixel_Fourier = Pixel_Ang/57 * Pad_Box_Size;

    img2 = double(pad_image);
     
   Outside_Radius_Ang = Pixel_Ang * 2 + 0.2;  %%  Changed K3 
 
   lattice_sub = bg_push_by_rot(img2,Threshold,expand_pixel,Pixel_Ang,Inside_Radius_Ang,Outside_Radius_Ang);
   out_sub = lattice_sub ; 
   if ( pad_out_opt == 0 ) 
      x_cut = Pad_Origin_X + row_count - 1;
      y_cut = Pad_Origin_Y + column_count - 1;  
      out_sub = lattice_sub(Pad_Origin_X:x_cut, Pad_Origin_Y:y_cut); 
   end  
   WriteMRC(out_sub,1,name_sub);

%%%%%%%%%%%%%%%%%%
   
